<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\MAN\Utilities\Util;
use Teknisa\MAN\Services;

class BloqueioLoja extends CrudWithParameterBag {

     protected $dataSourceName = 'bloqueioLoja';

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Services\BloqueioLojaService $bloqueioLoja) {
        $this->bloqueioLoja = $bloqueioLoja;
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function find (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceName;
        $this->parameterBagColumns = array('NRORG', 'CDFILIAL', 'CDLOJA');
        parent::find($request, $response);
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows()[0];
            
            if ($rows['multiple']){
                $this->bloqueioLoja->bloqueiaLojas($rows['stores'], $rows['__is_new']);
            }
            else{
                $this->bloqueioLoja->bloqueiaLoja($rows['stores'], $rows['__is_new']);
            }
            
           
        } catch (\Exception $e) {
            
            if((strpos($e->getMessage(), 'ORA-00001') != false)) {
                $response->addMessage(new Message(1));
            } else {
                $response->addMessage(new Message(0));
            }
            
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function delete(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            foreach($rows as $row){
                $this->bloqueioLoja->desbloqueiaLoja($row['NRORG'], $row['CDFILIAL'], $row['CDLOJA'], $row['CDOPERADOR'], $row['NRDIASEMANABLOQ']);
            }
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    } 
}    